# U.S. Forms System

The US Forms System is an open source library and set of guiding principles for building complex web-based forms using [React](https://reactjs.org), the [JSON Schema standard](http://json-schema.org/), and the [US Web Design System](https://designsystem.digital.gov/).

***THIS IS A WORK IN PROGRESS.***

### About this project

Inspired by Mozilla's [react-jsonschema-form](https://github.com/mozilla-services/react-jsonschema-form) library, the US Forms System is specifically intended for consistently styled governmental web-based forms. This library enables you to describe form fields in a JSON Schema configuration file, which then renders the backing React components necessary to build your form. You'll build forms significantly faster than existing methods, and benefit from the US Web Design System's best practices in user experience and data collection, validation, and transmission.

### Using the library

For information about setting up and using the US Forms System, see the *[US Forms System Documentation](./docs/README.md)*.

Additionally, the [US Forms System Starter App](https://github.com/usds/us-forms-system-starter-app) provides the basic files and configuration needed to get started building a form using the US Forms System.

### Contributing to this project:

Please read our [Code of Conduct](https://github.com/usds/us-forms-system/blob/master/CODE_OF_CONDUCT.md) and [CONTRIBUTING.md](https://github.com/usds/us-forms-system/blob/master/CONTRIBUTING.md) for more details.

#### Join the contributor mailing list: 

To receive regular updates about this project, please join our mailing list by sending an email to forms-subscribe-request@listserv.gsa.gov. 

#### Contact the project team:

If you want to directly contact the project team, you can send your questions to forms@lists.usds.gov. 

### More project artifacts

- Roadmap, research, and process: [US Forms System Wiki](https://github.com/usds/us-forms-system/wiki)
- Project progress: [US Forms System Project Board](https://github.com/orgs/usds/projects/3)
