# US Forms System Documentation

- [Getting started with the US Forms System](getting-started/README.md)
  - [Tools for getting started with the US Forms System](getting-started/tools-for-getting-started-with-the-us-forms-system.md)
  - [Creating a new application with the US Forms System Starter App](getting-started/creating-a-new-application-with-the-us-forms-system-starter-app.md)
  - [Tutorial: Building a simple address form](getting-started/tutorial.md)
  - [Installing the US Forms System in an existing application](getting-started/installing-the-us-forms-system-in-an-existing-application.md)
- [Building a form](building-a-form/README.md)
  - [About the `schema` and `uiSchema` objects](building-a-form/about-the-schema-and-uischema-objects.md)
  - [Quick Start: Example `form.js` file](building-a-form/quick-start-example-formjs-file.md)
  - [Creating a form config file](building-a-form/creating-a-form-config-file.md)
  - [Available form features and usage guidelines](building-a-form/available-form-features-and-usage-guidelines.md)
  - [Available widgets](building-a-form/available-widgets.md)
  - [Common definitions](building-a-form/common-definitions.md)
  - [Common patterns for building forms](building-a-form/common-patterns-for-building-forms.md)
- [Customizing the library](customizing-the-library/README.md)
  - [About the React component hierarchy](customizing-the-library/about-the-react-component-hierarchy.md)
  - [Creating custom fields and widgets](customizing-the-library/creating-custom-fields-and-widgets.md)
